View Issue Details

IDProjectCategoryView StatusLast Update
0038065LazarusDebuggerpublic2021-01-07 23:03
ReporterPascal Riekenberg Assigned ToMartin Friebe  
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
Platformi386OSWindows 10 x64 
Product Version2.0.11 (SVN) 
Fixed in Version2.2 
Summary0038065: fpDebug: occasional crashes when stopping hanging App
DescriptionEAccessViolation when stopping an hanging App

see trace below
Additional InformationTDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TDbgWinProcess.Continue False
TApplication.HandleException: EAccessViolation
Access violation
  Stack trace:
  $00000001001EC130 MAPDESTROYED, line 621 of maps.pp
  $00000001001EAE2B DESTROY, line 295 of maps.pp
  $000000010001451F Free, line 336 of ../inc/objpas.inc
  $000000010003E97C FreeAndNil, line 160 of ../objpas/sysutils/sysutils.inc
  $0000000100E8D55C DESTROY, line 4334 of fpdbgdwarfdataclasses.pas
  $000000010001451F Free, line 336 of ../inc/objpas.inc
  $0000000100E8860B DESTROY, line 3373 of fpdbgdwarfdataclasses.pas
  $000000010001451F Free, line 336 of ../inc/objpas.inc
  $000000010003E97C FreeAndNil, line 160 of ../objpas/sysutils/sysutils.inc
  $0000000100E0A194 DESTROY, line 1561 of fpdbgclasses.pp
  $0000000100E0AD2F DESTROY, line 1746 of fpdbgclasses.pp
  $0000000100EA7451 DESTROY, line 498 of fpdbgwinclasses.pas
  $000000010001451F Free, line 336 of ../inc/objpas.inc
  $0000000100E78EF5 SENDEVENTS, line 1802 of fpdbgcontroller.pas
  $0000000100EE88EC DEBUGLOOPFINISHED, line 4140 of fpdebugdebugger.pas
  $000000010005ECFE PROCESSASYNCCALLQUEUE, line 1038 of include/application.inc
  $00000001001F8E03 DOWINDOWPROC, line 2059 of win32/win32callback.inc
TagsNo tags attached.
Fixed in Revision64266
LazTarget2.2
WidgetsetWin32/Win64
Attached Files

Activities

Martin Friebe

2020-12-22 14:40

manager   ~0127762

The issue was reported 2.0.11 => The trace suggests that it was actually 2.1 only.

For some (invalid) reason when the debugger stopped, it would try to evaluate current "Locals". This would run in a thread, while the main thread would destroy important structures in FpDebug.
Safeguards where added to TLocals, and improved on Watches, Stack, ....

Also if the debugger gets stopped after entering Pause, any task started for the pause will be stopped.


Issue History

Date Modified Username Field Change
2020-11-11 15:20 Pascal Riekenberg New Issue
2020-11-11 15:20 Pascal Riekenberg Status new => assigned
2020-11-11 15:20 Pascal Riekenberg Assigned To => Martin Friebe
2020-11-11 15:33 Pascal Riekenberg Summary fpDebug: occasional crashes => fpDebug: occasional crashes when stopping hanging App
2020-11-11 15:33 Pascal Riekenberg Description Updated View Revisions
2020-11-11 15:33 Pascal Riekenberg LazTarget => -
2020-11-11 15:33 Pascal Riekenberg Widgetset Win32/Win64 => Win32/Win64
2020-12-22 14:40 Martin Friebe Status assigned => resolved
2020-12-22 14:40 Martin Friebe Resolution open => fixed
2020-12-22 14:40 Martin Friebe Fixed in Version => 2.2
2020-12-22 14:40 Martin Friebe Fixed in Revision => 64266
2020-12-22 14:40 Martin Friebe LazTarget - => 2.2
2020-12-22 14:40 Martin Friebe Widgetset Win32/Win64 => Win32/Win64
2020-12-22 14:40 Martin Friebe Note Added: 0127762
2021-01-07 23:03 Pascal Riekenberg Status resolved => closed